unit UnitPremiumPrintScreen;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, Menus, math, clipbrd, StdCtrls, pngimage, Buttons, shellapi,
  jpeg, quickbitmap, strutils, unitclipform, registry;

type
  TForm1 = class(TForm)
    TrayIcon1: TTrayIcon;
    PopupMenu1: TPopupMenu;
    S1: TMenuItem;
    Donotstartonwindowsstartup1: TMenuItem;
    Exit1: TMenuItem;
    Timer1: TTimer;
    Help: TMenuItem;
    bg: TImage;
    Image1: TImage;
    SpeedButton1: TSpeedButton;
    lblInfo2: TLabel;
    lblInfo: TLabel;
    EditImage: TImage;
    OpenFolder: TImage;
    RecordVideo: TImage;
    ConvertToText: TImage;
    OpenFolderPopupBtn: TImage;
    EditImagePopupBtn: TImage;
    ConvertToTextPopupBtn: TImage;
    OpenFolderpp: TPopupMenu;
    EditImagepp: TPopupMenu;
    ConvertToTextpp: TPopupMenu;
    RecordVideopp: TPopupMenu;
    optImagesFolder: TMenuItem;
    optOCRFolder: TMenuItem;
    optVideoFolder: TMenuItem;
    optClearAllFolders: TMenuItem;
    optEditWithMSPaint: TMenuItem;
    optEditWithDefaultEditor: TMenuItem;
    Englis1: TMenuItem;
    English1: TMenuItem;
    French1: TMenuItem;
    Germany1: TMenuItem;
    Italy1: TMenuItem;
    Portuguese1: TMenuItem;
    Russian1: TMenuItem;
    Spain1: TMenuItem;
    optSlowMotionFolder: TMenuItem;
    optRecordVideo: TMenuItem;
    optRecordSlowMotion: TMenuItem;
    RecordVideoPopupBtn: TImage;
    optVideoFormat: TMenuItem;
    optVideoQuality: TMenuItem;
    lbl1: TLabel;
    lbl2: TLabel;
    lbl3: TLabel;
    lbl4: TLabel;
    lbl5: TLabel;
    lblHelp: TLabel;
    optRenderVideoUsingRecentConfiguration: TMenuItem;
    Open1: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure HelpClick(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure TrayIcon1Click(Sender: TObject);
    procedure bgMouseEnter(Sender: TObject);
    procedure EditImageClick(Sender: TObject);
    procedure OpenFolderClick(Sender: TObject);
    procedure ConvertToTextClick(Sender: TObject);
    procedure OpenFolderPopupBtnClick(Sender: TObject);
    procedure optImagesFolderClick(Sender: TObject);
    procedure RecordVideoClick(Sender: TObject);
    procedure optClearAllFoldersClick(Sender: TObject);
    procedure TrayIcon1BalloonClick(Sender: TObject);
    procedure S1Click(Sender: TObject);
    procedure Donotstartonwindowsstartup1Click(Sender: TObject);
    procedure optRenderVideoUsingRecentConfigurationClick(Sender: TObject);
  private
    optAVCodecwmv: TMenuItem;
    optAVCodecmp4: TMenuItem;
    optAVCodecflv: TMenuItem;
    optAVCodecmov: TMenuItem;
    optAVCodecvp8: TMenuItem;
    optAVQualitylow: TMenuItem;
    optAVQualitymediumlow: TMenuItem;
    optAVQualitymedium: TMenuItem;
    optAVQualityhigh: TMenuItem;
    optAVQualityveryhigh: TMenuItem;
    { Private declarations }
  public
    StartPoint:Tpoint;
    StopPoint:Tpoint;
    NewCursorPoint:Tpoint;
    OldCursorPoint:Tpoint;
    HoldingPositionSince:double;
    LastCapturedScreen:TBitmap;
    counter:double;
    timecounter:double;
    //blinker:TBlinker;
    procedure DrawRect;
    function getscreen:boolean;
    procedure ShowCapturedImage;
    function fitBitmapToRectangle(source:TBitmap; aWidth:integer; aHeight:integer):TBitmap;
    procedure CreateDirectories;
    procedure CreateDirectory(aDir:string);
    procedure SaveLastCapturedScreen;
    procedure LoadOCRText;
    procedure DetectCreatedVideo;
    procedure SaveSetup;
    procedure LoadSetup;
    procedure CreateAVSubmenu;
    procedure SetupVideoOptions;
    { Public declarations }
  end;

var
  Form1: TForm1;
  LastOCRFilename:string;
  LastImageFilename:string;

const
  fadeinStarts = 4;
  fadeinEnds = 3.5;
  fadeoutStarts = 0.5;
  fadeoutEnds = 0;

implementation

{$R *.dfm}

procedure TForm1.bgMouseEnter(Sender: TObject);
begin
  counter:=1000000000;
end;

procedure TForm1.ConvertToTextClick(Sender: TObject);
var
  qb:TQuickBitmap;
  qb2:TQuickBitmap;
  png:TPNGImage;
  filename:string;
  language:string;
  scalefactor:integer;
begin
  try
    //show hing
    trayicon1.BalloonHint:='Starting optical character recognition.';
    trayicon1.BalloonTitle:='Info';
    trayicon1.BalloonTimeout:=3;
    trayicon1.ShowBalloonHint;
    //hide form
    counter:=fadeoutEnds;
    showwindow(handle,sw_hide);
    application.ProcessMessages;
    sleep(100);

    //scale image and save it to png
    qb:=TQuickBitmap.create(lastcapturedscreen);
    //compute scalefactor
    scalefactor:=floor(16000/max(qb.width,qb.height));
    scalefactor:=min(10,scalefactor);
    qb2:=qb.QuickBicubicResize(scalefactor,scalefactor);
    filename:=path+PublishedOCR+'\img1.png';
    LastOCRFilename:=path+PublishedOCR+'\'+GetUID();
    png:=TPNGImage.Create;
    try
      png.Assign(qb2.GetBitmap());
      png.SaveToFile(filename);
    finally
      png.Free;
      qb.destroy;
      qb2.destroy;
    end;

    if ConvertToTextpp.Items[0].Checked then language:='ces';
    if ConvertToTextpp.Items[1].Checked then language:='eng';
    if ConvertToTextpp.Items[2].Checked then language:='fra';
    if ConvertToTextpp.Items[3].Checked then language:='deu';
    if ConvertToTextpp.Items[4].Checked then language:='ita';
    if ConvertToTextpp.Items[5].Checked then language:='por';
    if ConvertToTextpp.Items[6].Checked then language:='rus';
    if ConvertToTextpp.Items[7].Checked then language:='spa';

    //recognize text
    shellexecute(handle,'open',pchar(path+TesseractDir+'\tesseract.exe'),
                 pchar('-l '+language+' -psm 1 "'+filename+'" "'+LastOCRFilename+'"'),
                 pchar(path+TesseractDir),sw_hide);
  except

  end;
end;

procedure TForm1.CreateAVSubmenu;
var SubItem:TMenuItem;
begin
  //wmv
  SubItem:=TMenuItem.Create(optVideoFormat);
  SubItem.Caption:='WMV (Windows Media Video)';
  SubItem.name:='optAVCodecwmv1';
  SubItem.GroupIndex:=10;
  SubItem.Checked:=true;
  SubItem.RadioItem:=true;
  SubItem.OnClick:=optImagesFolderClick;
  optVideoFormat.Add(SubItem);
  optAVCodecwmv:=SubItem;

  //mpeg4
  SubItem:=TMenuItem.Create(optVideoFormat);
  SubItem.Caption:='MPEG4';
  SubItem.name:='optAVCodecmp4';
  SubItem.GroupIndex:=10;
  SubItem.RadioItem:=true;
  SubItem.OnClick:=optImagesFolderClick;
  optVideoFormat.Add(SubItem);
  optAVCodecmp4:=SubItem;

  //flv
  SubItem:=TMenuItem.Create(optVideoFormat);
  SubItem.Caption:='FLV (Flash Video)';
  SubItem.name:='optAVCodecflv';
  SubItem.GroupIndex:=10;
  SubItem.RadioItem:=true;
  SubItem.OnClick:=optImagesFolderClick;
  optVideoFormat.Add(SubItem);
  optAVCodecflv:=SubItem;

  //mov
  SubItem:=TMenuItem.Create(optVideoFormat);
  SubItem.Caption:='MOV (Quick Time Movie)';
  SubItem.name:='optAVCodecmov';
  SubItem.GroupIndex:=10;
  SubItem.RadioItem:=true;
  SubItem.OnClick:=optImagesFolderClick;
  optVideoFormat.Add(SubItem);
  optAVCodecmov:=SubItem;

  //webm
  SubItem:=TMenuItem.Create(optVideoFormat);
  SubItem.Caption:='WebM (VP8)';
  SubItem.name:='optAVCodecwebm';
  SubItem.GroupIndex:=10;
  SubItem.RadioItem:=true;
  SubItem.OnClick:=optImagesFolderClick;
  optVideoFormat.Add(SubItem);
  optAVCodecvp8:=SubItem;

  //quality low
  SubItem:=TMenuItem.Create(optVideoQuality);
  SubItem.Caption:='Quality Low';
  SubItem.name:='optAVQualitylow';
  SubItem.GroupIndex:=20;
  SubItem.RadioItem:=true;
  SubItem.Break:=TMenuBreak.mbBarBreak;
  SubItem.OnClick:=optImagesFolderClick;
  optVideoQuality.Add(SubItem);
  optAVQualitylow:=SubItem;

  //quality medium
  SubItem:=TMenuItem.Create(optVideoQuality);
  SubItem.Caption:='Quality Medium Low';
  SubItem.name:='optAVQualitymediumlow';
  SubItem.GroupIndex:=20;
  SubItem.RadioItem:=true;
  SubItem.OnClick:=optImagesFolderClick;
  optVideoQuality.Add(SubItem);
  optAVQualitymediumlow:=SubItem;

  //quality medium
  SubItem:=TMenuItem.Create(optVideoQuality);
  SubItem.Caption:='Quality Medium';
  SubItem.name:='optAVQualitymedium';
  SubItem.GroupIndex:=20;
  SubItem.RadioItem:=true;
  SubItem.OnClick:=optImagesFolderClick;
  optVideoQuality.Add(SubItem);
  optAVQualitymedium:=SubItem;

  //quality high
  SubItem:=TMenuItem.Create(optVideoQuality);
  SubItem.Caption:='Quality High';
  SubItem.name:='optAVQualityhigh';
  SubItem.GroupIndex:=20;
  SubItem.RadioItem:=true;
  SubItem.OnClick:=optImagesFolderClick;
  optVideoQuality.Add(SubItem);
  optAVQualityhigh:=SubItem;

  //quality very high
  SubItem:=TMenuItem.Create(optVideoQuality);
  SubItem.Caption:='Quality Very High';
  SubItem.name:='optAVQualityveryhigh';
  SubItem.GroupIndex:=20;
  SubItem.Checked:=true;
  SubItem.RadioItem:=true;
  SubItem.OnClick:=optImagesFolderClick;
  optVideoQuality.Add(SubItem);
  optAVQualityveryhigh:=SubItem;
end;

procedure TForm1.CreateDirectories;
begin
  CreateDirectory(path+PublishedData);
  CreateDirectory(path+PublishedOCR);
  CreateDirectory(path+PublishedSlowMotion);
  CreateDirectory(path+PublishedVideo);
  CreateDirectory(path+TempVideo);
end;

procedure TForm1.CreateDirectory(aDir: string);
begin
  if(not ForceDirectories(aDir)) then
  begin
    messagebox(handle,pchar('Cannot create directory "'+aDir+'". Please create it manually.'),'Info',mb_ok or mb_iconinformation);
  end;
end;

procedure TForm1.DetectCreatedVideo;
begin
  //detect video
  if (RecordingVideoStatus=RenderingVideo) then
  begin
    RecordingVideoStatus:=RenderingVideoAccepted;
    trayicon1.BalloonHint:='Rendering video. Please wait.';
    trayicon1.BalloonTitle:='Info';
    trayicon1.BalloonTimeout:=3;
    trayicon1.ShowBalloonHint;
  end;
  if (RecordingVideoStatus=VideoRendered) then
  begin
    RecordingVideoStatus:=NotRecordingVideo;
    trayicon1.BalloonHint:='Video "'+LastVideoFilename+'" was created.';
    trayicon1.BalloonTitle:='Video Rendered';
    trayicon1.BalloonTimeout:=3;
    trayicon1.ShowBalloonHint;
  end;
end;

procedure TForm1.Donotstartonwindowsstartup1Click(Sender: TObject);
var key: string;
     Reg: TRegIniFile;
begin
  //unregister application
  key := '\Software\Microsoft\Windows\CurrentVersion\Run';
  Reg:=TRegIniFile.Create;
  try
    Reg.RootKey:=HKEY_CURRENT_USER;
    if Reg.OpenKey(Key,False) then Reg.DeleteValue('PremiumPrintScreen');
    messagebox(handle,pchar('Application will not be automatically started after Windows Startup.'),'Info',mb_ok or mb_iconinformation);
  finally
    Reg.Free;
  end;
end;

procedure TForm1.DrawRect;
begin
  //dc:=getdc(0);
  getcursorpos(NewCursorPoint);
  ClipForm.ClipRect:=rect(StartPoint,NewCursorPoint);
  //zjisti jestli se kurzor pohnul
  if((NewCursorPoint.X<>OldCursorPoint.X) or
     (NewCursorPoint.Y<>OldCursorPoint.Y)) then
  begin
      if(timecounter-HoldingPositionSince)>1 then
      begin
        ClipForm.HideClipForm;
        //if(blinker<>nil) then blinker.clear;
      end;
      HoldingPositionSince:=timecounter;
      OldCursorPoint:=NewCursorPoint;
  end
  //zjisti jestli je kurzor mysi na pozicidele nez 5 vterin
  //pokud ano, tak zahaji blikani
  else if(timecounter-HoldingPositionSince)>1 then
  begin
    ClipForm.ShowClipForm;
    //if(blinker=nil) then blinker:=TBlinker.create(rect(StartPoint,NewCursorPoint));
    //blinker.setrect(rect(StartPoint,NewCursorPoint));
    //blinker.blink(timer1.Interval/1000);
  end;
end;

procedure TForm1.Exit1Click(Sender: TObject);
begin
  close;
end;

function TForm1.fitBitmapToRectangle(source: TBitmap; aWidth,
  aHeight: integer): TBitmap;
  var aspect:double;
      newWidth:integer;
      newHeight:integer;
begin
  //pripravi vyslednou bitampu
  result:=TBitmap.Create();
  result.Width:=aWidth;
  result.Height:=aHeight;
  result.Canvas.Brush.Color:=clblack;
  result.Canvas.FillRect(rect(-1,-1,result.Width,result.Height));

  //compute new width and height
  aspect:=source.width/source.height;
  newWidth:=aWidth;
  newHeight:=floor(aWidth/aspect);
  if (newHeight>aHeight) then
  begin
    newHeight:=aHeight;
    newWidth:=floor(aHeight*aspect);
  end;

  //bitblt
  SetStretchBltMode(result.Canvas.Handle, HALFTONE);
  stretchblt(result.Canvas.Handle,(aWidth div 2) - (newWidth div 2),
            (aHeight div 2) - (newHeight div 2), newWidth, newHeight,
            source.Canvas.Handle,0,0,source.Width,source.Height,srccopy);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  Hide();
  counter:=-1;
  timecounter:=1;
  Startpoint:=point(-1,-1);
  path:=extractfilepath(application.ExeName);
  path:=leftstr(path,length(path)-1);
  LastCapturedScreen:=tbitmap.Create;
  RecordingVideoStatus:=NotRecordingVideo;
  //create av submenu
  CreateAVSubmenu;
  //load setup
  LoadSetup;
end;

function TForm1.getscreen:boolean;
var dc:hdc;
    bitmap:TBitmap;
    BitmapRect:TRect;
begin
  try
    //default result is false
    result:=false;
    //
    dc:=getdc(0);

    BitmapRect:=rect(min(StartPoint.X,StopPoint.X),
                     min(StartPoint.Y,StopPoint.Y),
                     max(StartPoint.X,StopPoint.X),
                     max(StartPoint.Y,StopPoint.Y));

    if(BitmapRect.Right-BitmapRect.Left)<5 then exit;
    if(BitmapRect.Bottom-BitmapRect.Top)<5 then exit;
    //if(((BitmapRect.Right-BitmapRect.Left) * (BitmapRect.Bottom-BitmapRect.Top))<9) then exit;

    bitmap:=TBitmap.Create;
    bitmap.Width:=BitmapRect.Right-BitmapRect.Left;
    bitmap.Height:=BitmapRect.Bottom-BitmapRect.Top;

    bitblt(bitmap.Canvas.Handle,0,0,bitmap.Width,bitmap.Height,dc,BitmapRect.Left,BitmapRect.Top,SRCCOPY);
    clipboard.Open;
    clipboard.Clear;
    clipboard.Assign(bitmap);
    clipboard.Close;
    //ulozi naposledy zachycenou obrazovku
    lastcapturedscreen.Assign(bitmap);
    saveLastCapturedScreen;
    image1.Picture.Assign(fitBitmapToRectangle(bitmap,210,135));
    image1.BringToFront;
    bitmap.Destroy;
    //result is true
    result:=true;
  except
    result:=false;
  end;
end;

procedure TForm1.HelpClick(Sender: TObject);
begin
  //show help
  shellexecute(handle,'open',pchar(path+'\help\index.html'),nil,nil,sw_show);
end;

procedure TForm1.LoadOCRText;
var
  f:textfile;
  s:string;
  line:string;
begin
try
  //LoadOCRText2;
  //exit;
  //load text if file exists
  if (length(LastOCRFilename)>1) and (fileexists(LastOCRFilename+'.txt',false)) then
  begin
    AssignFile(f, LastOCRFilename+'.txt');
    reset(f);
    while not Eof(f) do
    begin
      ReadLn(f, line);
      s:=s+line+chr(13)+chr(10);
    end;
    closefile(f);

    clipboard.Open;
    clipboard.Clear;
    clipboard.AsText:=utf8towidestring(s);
    clipboard.Close;
    //clear last ocr filename
    LastOCRFileName:='';

    trayicon1.BalloonHint:='Optical character recognition is finished. '+
                           'Open your favourite text editor and paste '+
                           'clipboard content into it (using Ctrl+v).';
    trayicon1.BalloonTitle:='Info';
    trayicon1.BalloonTimeout:=3;
    trayicon1.ShowBalloonHint;
  end;
except
end;
end;

procedure TForm1.LoadSetup;
var f:textfile;
    s:string;
    strings:TStrings;
begin
try
  //read last line of the file
  if(not(fileexists(path+'\setup.csv'))) then
  begin
    savesetup;
    trayicon1.BalloonHint:='Premium Print Screen has been started.';
    trayicon1.BalloonTitle:='Info';
    trayicon1.BalloonTimeout:=3;
    trayicon1.ShowBalloonHint;
    exit;
  end;
  assignfile(f,path+'\setup.csv');
  reset(f);
  while not(eof(f)) do
    readln(f,s);
  closefile(f);

  //split string
  strings:=TStringList.Create;
  strings.Delimiter:=';';
  strings.DelimitedText:=s;

  OpenFolderpp.Items[strtoint(strings[0])].Checked:=true;
  EditImagepp.Items[strtoint(strings[1])].Checked:=true;
  ConvertToTextpp.Items[strtoint(strings[2])].Checked:=true;
  RecordVideopp.Items[strtoint(strings[3])].Checked:=true;
  optVideoFormat.Items[strtoint(strings[4])].Checked:=true;
  optVideoQuality.Items[strtoint(strings[5])].Checked:=true;
except
end;
end;

procedure TForm1.OpenFolderClick(Sender: TObject);
var filename:string;
begin
  //folder
  if OpenFolderpp.Items[0].Checked then filename:=path+PublishedData;
  if OpenFolderpp.Items[1].Checked then filename:=path+PublishedOCR;
  if OpenFolderpp.Items[2].Checked then filename:=path+PublishedSlowMotion;
  if OpenFolderpp.Items[3].Checked then filename:=path+PublishedVideo;
  //open mspaint
  shellexecute(0,'open',pchar(filename),nil,pchar(path),sw_show);
  //hide form
  counter:=fadeoutEnds;
end;

procedure TForm1.OpenFolderPopupBtnClick(Sender: TObject);
var
  p:TPoint;
  popup:TPopupMenu;
  a:integer;
  aname:string;
begin
  //search for popup menu instance
  popup:=nil;
  aname:=(sender as TComponent).Name;
  aname:=leftstr(aname,pos('Popup',aname)-1)+'pp';
  for a := 0 to form1.ComponentCount do
  begin
    if((form1.Components[a] as TComponent).Name=aname) then
    begin
      popup:=form1.Components[a] as TPopupMenu;
      break;
    end;
  end;
  if(popup=nil) then exit;
  //open popup menu instance
  p:=point((sender as TControl).Left-40,form1.Height);
  p:=form1.ClientToScreen(p);
  popup.Popup(p.x,p.y);
end;

procedure TForm1.optClearAllFoldersClick(Sender: TObject);
begin
  //if MessageBox(handle,'Do you really want to clear all folders?',
	//  		        'Clear all folders',
  // 			        MB_YESNO Or MB_ICONQUESTION) = IDYES then
  begin
    DeleteFiles(path+PublishedData+'\*.*');
    DeleteFiles(path+PublishedOCR+'\*.*');
    DeleteFiles(path+PublishedSlowMotion+'\*.*');
    DeleteFiles(path+PublishedVideo+'\*.*');
    DeleteFiles(path+TempVideo+'\*.*');

    trayicon1.BalloonHint:='Folders were cleared.';
    trayicon1.BalloonTitle:='Info';
    trayicon1.BalloonTimeout:=3;
    trayicon1.ShowBalloonHint;
  end;
end;

procedure TForm1.optImagesFolderClick(Sender: TObject);
var
  item:TMenuItem;
  popup:TPopupMenu;
  image:TImage;
begin
  //change checkbox and click on the image
  item:=(Sender as TMenuItem);
  item.Checked:=true;
  SaveSetup;
  //click on the image if it is not audio video submenu
  if(pos('optAV',item.Name)<=0) then
  begin
    popup:=(item.GetParentComponent as TPopupMenu);
    image:=form1.FindComponent(leftstr(popup.Name,length(popup.Name)-2)) as TImage;
    image.OnClick(nil);
  end;
end;

procedure TForm1.optRenderVideoUsingRecentConfigurationClick(Sender: TObject);
var renderingthread:cardinal;
begin
  SetupVideoOptions;
  //render video
  beginthread(nil,0,RenderVideo,nil,0,renderingthread);
end;

procedure TForm1.RecordVideoClick(Sender: TObject);
begin
  //hide form
  counter:=fadeoutEnds;
  showwindow(handle,sw_hide);
  application.ProcessMessages;
  sleep(100);
  //show record form
  //if video is not beeing recorded then record video
  //if video is beeing recorded or rendered then show information
  if(RecordingVideoStatus=NotRecordingVideo) then
  begin
    SetupVideoOptions;
    ClipForm.ShowRecording(optRecordSlowMotion.Checked);
  end
  else
  begin
    messagebox(handle,pchar('Previous video was not rendered. Please wait until rendering is finished.'),'Info',mb_ok or mb_iconinformation);
  end;
end;

procedure TForm1.EditImageClick(Sender: TObject);
begin
  if (length(LastImageFilename)<=1) then exit;
  //open mspaint
  if (EditImagepp.Items[0].Checked) then
    shellexecute(0,'open','mspaint',pchar(LastImageFilename),'.',sw_show)
  else if(EditImagepp.Items[1].Checked) then
    shellexecute(0,'open',pchar(LastImageFilename),nil,'.',sw_show);
  //hide form
  counter:=fadeoutEnds;
end;

procedure TForm1.S1Click(Sender: TObject);
var key: string;
     Reg: TRegIniFile;
begin
  //register application on windows startup
  key := '\Software\Microsoft\Windows\CurrentVersion\Run';
  Reg := TRegIniFile.Create;
  try
    Reg.RootKey:=HKEY_CURRENT_USER;
    Reg.CreateKey(Key);
    if Reg.OpenKey(Key,False) then Reg.WriteString(key, 'PremiumPrintScreen', Application.ExeName);
    messagebox(handle,pchar('Application will be automatically started after Windows Startup.'),'Info',mb_ok or mb_iconinformation);
  finally
    Reg.Free;
  end;
end;

procedure TForm1.SaveLastCapturedScreen;
var jpg: TJpegImage;
    png:TPNGImage;
    uid:string;
begin
  CreateDirectories;
  uid:=GetUID();
  png:=TPNGImage.Create;
  try
    try
      png.Assign(LastCapturedScreen);
      LastImageFilename:=path+PublishedData+'\'+uid+'.png';
      png.SaveToFile(LastImageFilename);
    except
      LastImageFilename:=path+PublishedData+'\'+uid+'.bmp';
      LastCapturedScreen.SaveToFile(LastImageFilename);
    end;
  finally
    png.Free;
  end;
  jpg:=TJpegImage.Create;
  jpg.Assign(LastCapturedScreen);
  jpg.SaveToFile(path+PublishedData+'\'+uid+'.jpg');
end;




procedure TForm1.SaveSetup;
var f:textfile;
    s:string;

  function getselecteditem(popup:TPopupMenu;startitemindex:integer):integer; overload;
  var a:integer;
  begin
    result:=0;
    for a := startitemindex to popup.Items.Count-1 do
      if popup.Items[a].Checked=true then
      begin
        result:=a;
        break;
      end;
  end;

  function getselecteditem(item:TMenuItem;startitemindex:integer):integer; overload;
  var a:integer;
  begin
    result:=0;
    for a := startitemindex to item.Count-1 do
      if item.Items[a].Checked=true then
      begin
        result:=a;
        break;
      end;
  end;
begin
try
  assignfile(f,path+'\setup.csv');
  rewrite(f);
  writeln(f,'OpenFolderCheckedItem;EditImageCheckedItem;OCRCheckedItem;VideoCheckedItem;VideoFormat;VideoQuality');
  s:=inttostr(getselecteditem(OpenFolderpp,0));
  s:=s+';'+inttostr(getselecteditem(EditImagepp,0));
  s:=s+';'+inttostr(getselecteditem(ConvertToTextpp,0));
  s:=s+';'+inttostr(getselecteditem(RecordVideopp,0));
  s:=s+';'+inttostr(getselecteditem(optVideoFormat,0));
  s:=s+';'+inttostr(getselecteditem(optVideoQuality,0));
  writeln(f,s);
  closefile(f);
except
end;
end;




procedure TForm1.SetupVideoOptions;
begin
  //change video codec
  if optAVCodecwmv.checked then VideoCodec:='wmv'
  else if optAVCodecmp4.checked then VideoCodec:='mp4'
  else if optAVCodecflv.checked then VideoCodec:='flv'
  else if optAVCodecmov.checked then VideoCodec:='mov'
  else if optAVCodecvp8.checked then VideoCodec:='webm';

  //change video quality
  if optAVQualityveryhigh.checked then VideoQuality:=5
  else if optAVQualityhigh.checked then VideoQuality:=15
  else if optAVQualitymedium.checked then VideoQuality:=17
  else if optAVQualitymediumlow.checked then VideoQuality:=21
  else if optAVQualitylow.checked then VideoQuality:=35;
end;

procedure TForm1.ShowCapturedImage;
begin
  //show window
  counter:=fadeinStarts;
end;

procedure TForm1.SpeedButton1Click(Sender: TObject);
begin
  //hide window
  counter:=fadeoutEnds;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
var clipboardbitmap:TBitmap;
begin
  //if recording is shown then exit
  if(ClipForm.isShowingRecording) then exit;
  //try to load ocr text if file exists

  LoadOCRText;
  //try to detect created video
  DetectCreatedVideo;

  //update counter
  counter:=counter-(Timer1.Interval/1000);
  timecounter:=timecounter+(Timer1.Interval/1000);

  //if counter is higher then 0 than fade in or fade out
  if (counter>fadeinStarts) then
  begin
    alphablendvalue:=255;
    windowstate:=wsNormal;
    lblInfo.Caption:='';
    show();
  end
  else if (counter>fadeinEnds) then
  begin
    alphablendvalue:=Math.Floor((255/(fadeinStarts-fadeinEnds))*abs(counter-fadeinStarts));
    windowstate:=wsNormal;
    lblInfo.Caption:=inttostr(Math.Floor(counter-fadeoutEnds+1));
    show();
  end
  else if (counter>fadeoutStarts) then
  begin
    alphablendvalue:=255;
    windowstate:=wsNormal;
    lblInfo.Caption:=inttostr(Math.Floor(counter-fadeoutEnds+1));
    //show form every two seconds
    //if((counter-floor(counter)<0.01) and (floor(counter) mod 2=0)) then show();
  end
  else if (counter>fadeoutEnds) then
  begin
    alphablendvalue:=Math.Floor((255/(fadeinStarts-fadeinEnds))*(counter-fadeoutEnds));
    windowstate:=wsNormal;
    lblInfo.Caption:=inttostr(Math.Floor(counter-fadeoutEnds+1));
    //show();
  end
  else
  begin
    windowstate:=wsMinimized;
    lblInfo.Caption:='';
    hide();
  end;


  //GetKeyboardState(KeybState);
  //if alt is pressed
  //If (KeybState[VK_MENU] and 128)=128 then
  If (getasynckeystate(VK_MENU)<>0) then
  begin
    //pokud byl alt zmacknuty behem nekolika poslednich okamziku
    if(Startpoint.X=-1) then
    begin
      getcursorpos(StartPoint);
      StopPoint:=StartPoint;
      HoldingPositionSince:=timecounter;
    end;

    getcursorpos(NewCursorPoint);
    ClipForm.ClipRect:=rect(StartPoint,NewCursorPoint);
    //if cursor is moving then reset time counter
    if(((NewCursorPoint.X<>OldCursorPoint.X) or
       (NewCursorPoint.Y<>OldCursorPoint.Y)) and
       ((timecounter-HoldingPositionSince)<=0.4)) then
    begin
      HoldingPositionSince:=timecounter;
    end;
    OldCursorPoint:=NewCursorPoint;
    //if cursor was stopped for at least 1 second then show rect
    if(timecounter-HoldingPositionSince)>0.4 then
    begin
      ClipForm.ShowClipForm;
    end;
  end
  //if alt is not pressed
  else
  begin
    //pokud byl alt pusten behem nekolika poslednich okamziku
    if((Startpoint.X<>-1) and (ClipForm.Visible)) then
    begin
      //hide clipform
      ClipForm.HideClipForm;
      getcursorpos(StopPoint);
      if (getscreen) then
      begin
        counter:=fadeinStarts;
      end;
    end;
    StartPoint:=point(-1,-1);
    //hide clipform anyway
    ClipForm.HideClipForm;
  end;

  {if(getasynckeystate(VK_SNAPSHOT)<>0) then
  begin
    if((lastcapturedscreen<>nil) and (Clipboard.HasFormat(CF_BITMAP))) then
    begin
      clipboardbitmap:=TBitmap.Create;
      clipboardbitmap.Assign(clipboard);
      if((clipboardbitmap.Width<>lastcapturedscreen.Width) and (clipboardbitmap.height<>lastcapturedscreen.Height)) then
      begin

      end;
    end;
  end;}
end;

procedure TForm1.TrayIcon1BalloonClick(Sender: TObject);
begin
  if(trayicon1.balloontitle='Video Rendered') then
  begin
    shellexecute(handle,'open',pchar(path+PublishedVideo+'\'),nil,nil,sw_show);
  end;
end;

procedure TForm1.TrayIcon1Click(Sender: TObject);
begin
  clipform.StopRecording;
  counter:=fadeinStarts;
end;

end.
